﻿package
{
	import flash.display.MovieClip;
	import flash.events.Event;
	
	public class Level1 extends MovieClip
	{
		private var player:Player;
		private var probNewObj:int;
		
		public function Level1()
		{
			addEventListener(Event.ADDED_TO_STAGE, onAddedToStage);
		}
		
		private function onAddedToStage(event:Event):void
		{
			removeEventListener(Event.ADDED_TO_STAGE, onAddedToStage);
			
			probNewObj = 2;
			
			// create the player, position them, add them to the stage
			player = new Player();
			player.x = (stage.stageWidth - panel.width) / 2;
			player.y = stage.stageHeight - player.height/2 - 10;
			addChild(player);
			
			// set the velocity of the background scrolling
			background.vy = 1;
			
			background.addEventListener(Event.ENTER_FRAME, moveBackground);
			player.addEventListener(Event.ENTER_FRAME, movePlayer);
			addEventListener(Event.ENTER_FRAME, addGameObjects);
		}
		
		private function moveBackground(event:Event):void
		{
			// scroll the background down the screen
			if (background.y != background.height){
				background.y += background.vy;
			}
			// when the background has all scrolled, the game is over
			else{
				probNewObj = 0;
				MovieClip(parent).gameOver = true;
			}
		}
		
		private function movePlayer(event:Event):void
		{
			// add code to move the player here
			// you can do it either by keyboard or by mouse
		}
		
		private function addGameObjects(event:Event):void
		{
			// put a new object on the stage at this frame?
			if (Math.ceil(Math.random()*100) <= probNewObj){
				var gameObj:GameObject = new GameObject;
				// position the object randomly just above the view of the player
				gameObj.x = Math.ceil(Math.random() * (stage.stageWidth - panel.width - gameObj.width)) + gameObj.width/2;
				gameObj.y = -1* Math.ceil(Math.random() * 100) + gameObj.height/2;
				// add object to the stage
				addChild(gameObj);
				// set the velocity of the player (can range from 1-3)
				gameObj.vy = Math.ceil((Math.random() + 0.25) * 2);
				// move the object each frame
				gameObj.addEventListener(Event.ENTER_FRAME, moveObject);
			}
		}
		
		private function moveObject(event:Event):void
		{
			var gameObj:GameObject = event.target as GameObject;
			gameObj.y += gameObj.vy;
		}
	}
}